package dev.peerat.parser.java.visitor.internal.chain;

import dev.peerat.parser.java.JavaElement;

public abstract class JavaVisitorChain<T extends JavaElement>{
	
	private JavaVisitorChain<?> next;
	
	public JavaVisitorChain<?> chain(JavaVisitorChain<?> next){
		return this.next = next;
	}
	
	public JavaVisitorChain<?> chain(){
		return this.next;
	}
	
	public boolean hasNext(){
		return this.next != null;
	}
	
	public abstract boolean visit(T element);
}