package dev.peerat.parser.visitor.bag;

import java.util.ArrayList;
import java.util.List;

public class ListVisitorBag extends VisitorBag{

	private List<Object> list;
	
	public ListVisitorBag(){
		this.list = new ArrayList<>();
	}
	
	@Override
	public void compute(Object... elements) {
		for(Object element : elements) list.add(element);
	}

	@Override
	public <T> T toElement(){
		return (T) list.get(0);
	}

	@Override
	public <T> List<T> toList(){
		return (List<T>) list;
	}

}
